#!/bin/bash

set -e

if [[ "$1" == "" ]]; then
  echo "Project ID required as first argument."
  exit 1
elif [[ "$1" == "auto" ]]; then
  ID=$(curl -s -H "PRIVATE-TOKEN: {{ gitlab_register_runner_access_token }}" "https://gitlab.lakedrops.com/api/v4/projects/?topic=needs_runner_{{ inventory_hostname }}" | jq -r '.[0].id')
  if [[ "$ID" == "null" ]]; then
    echo "Nothing to do"
    exit 0
  fi
  echo "Adding runner for project ID $ID"
  curl -X PUT -s -H "PRIVATE-TOKEN: {{ gitlab_register_runner_access_token }}" "https://gitlab.lakedrops.com/api/v4/projects/${ID}" -d "topics=runner_{{ inventory_hostname }}"
else
  ID=$1
fi

TOKEN=$(curl -s -X POST -H "PRIVATE-TOKEN: {{ gitlab_register_runner_access_token }}" --data "runner_type=project_type" --data "project_id=${ID}" --data "tag_list=deploylocal" "https://gitlab.lakedrops.com/api/v4/user/runners" | jq -r .token)
NAME=$(curl -s -H "PRIVATE-TOKEN: {{ gitlab_register_runner_access_token }}" "https://gitlab.lakedrops.com/api/v4/projects/${ID}" | jq -r .path_with_namespace)

gitlab-runner register --non-interactive --token "${TOKEN}" --name "Local deployment {{ inventory_hostname }}, ${NAME}" --url https://gitlab.lakedrops.com/ --executor docker --docker-image registry.lakedrops.com/docker/gitlab-drupal-ci/php-7.4 --docker-disable-cache --docker-volumes "/var/run/docker.sock:/var/run/docker.sock" --docker-volumes "/drupal/${ID}:/data"
